#ifndef DISJOINTSET_HH
#define DISJOINTSET_HH

//----------------------------------------------------------------------------
// union-find framework for disjoint sets
// copyright 2010 christopher rasmussen
// university of delaware
// v. 1.0
//----------------------------------------------------------------------------

#include <iostream>
#include <ctype.h>
#include <fstream>
#include <vector>
#include <cstdlib>
#include "sys/time.h"

using namespace std;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

class DisjointSet
{
public:

  DisjointSet(int);
  void print();
  void merge(int, int);
  int find(int);
  bool same_equivalence_class(int x, int y) { return find(x) == find(y); }

  vector <int> S;   // forest of trees
  int num_equivalence_classes;
  
};

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#endif
