#ifndef GAMESTATE_HH
#define GAMESTATE_HH

//----------------------------------------------------------------------------
// pacman-like game
// copyright 2010 christopher rasmussen
// university of delaware
// v. 1.01
// * all check_*() functions in GameState

//----------------------------------------------------------------------------

#include "BlockMaze.hh"
#include "Utils.hh"
#include "Agent.hh"

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

class Agent;

class GameState
{
public:
  GameState() { object_position.clear(); object_last_position.clear(); object_name.clear(); }

  void update(vector <Agent *> &, vector <Point_2D> &);
  bool check_for_runner_caught(int &) const;
  bool check_for_level_cleared() const;
  bool check_for_power_pill_eaten(int &, int &) const;
  bool arena_check_for_runner_caught(int &, BlockMaze *) const;
  bool arena_check_for_odd_level_cleared(BlockMaze *) const;
  bool arena_check_for_even_level_cleared(BlockMaze *) const;
  bool arena_check_for_power_pill_eaten(int &, int &, BlockMaze *) const;
  bool object_here(string, int, int) const;
  void remove_object(int);
  void print() const;
  int num_power_pills() const;

  int blue_ghost_wait_counter;            // how many more turns ghosts will be blue (0 if they're not)
  vector <Point_2D> object_position;      // positions of all agents, remaining power pills
  vector <Point_2D> object_last_position; // positions of all agents, remaining power pills in previous turn
  vector <string> object_name;            // agent names ("ghost...", "runner") or "power pill"
  int initial_num_power_pills;            // how many power pills were there to start?

};

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#endif
